/*
    Copyright (C) 2005-2007  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "gui.h"

int
dialog_show(GtkWidget *parent, const char *message, GtkMessageType msg_type, GtkButtonsType btn_type)
{
    GtkWidget *dialog;
    int retval;
    gboolean yes_no_cancel = FALSE;

    if (btn_type == (GTK_BUTTONS_YES_NO | GTK_BUTTONS_CANCEL)) {
        yes_no_cancel = TRUE;
        btn_type = GTK_BUTTONS_NONE;
    }

    dialog = gtk_message_dialog_new(GTK_WINDOW(parent), GTK_DIALOG_MODAL, msg_type, btn_type, "%s", message);

    if (yes_no_cancel) {
        gtk_dialog_add_buttons(GTK_DIALOG(dialog), GTK_STOCK_YES, GTK_RESPONSE_YES, GTK_STOCK_NO, GTK_RESPONSE_NO, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
    }

    retval = gtk_dialog_run(GTK_DIALOG(dialog));

    gtk_widget_destroy (dialog);

    return retval;
}
