/*
    Copyright (C) 2005-2007  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _NNTPGRAB_GUI_H_
#define _NNTPGRAB_GUI_H_

#ifdef _MSC_VER
#include "config.h.win32"
#else
#include "config.h"
#endif

#include <glib/gi18n.h>
#include <gtk/gtk.h>

#ifdef NNTPGRAB_NETWORKED
#include "nntpgrab_glue.h"
#else
#include "nntpgrab.h"
#endif

extern NNTPGrabCore *core;

int dialog_show(GtkWidget *parent, const char *message, GtkMessageType msg_type, GtkButtonsType btn_type);
GtkWidget *get_widget(const char *name);
#if GTK_CHECK_VERSION(2,12,0)
GObject *get_object(const char *name);
#endif

void do_open_nzb_file(const char *nzb_file);

#if GTK_CHECK_VERSION(2,10,0)
void         tray_destroy(void);
void         tray_create(void);
gboolean     tray_icon_get_is_shown(void);
#endif

#endif /* _NNTPGRAB_GUI_H_ */

