#ifndef _PAR2CHECK_H_
#define _PAR2CHECK_H_

typedef struct _par2_file_slice_checksum_part {
    unsigned char md5_hash[16];
    unsigned char crc[4];
} PAR2FileSliceChecksumPart;

typedef struct _par2file {
    const char filename[256];
    unsigned char file_id[16];
    unsigned char md5_hash_total[16];
    unsigned char md5_hash_16k[16];
    guint64 file_size;
    GList *slices;      // List containing PAR2FileChecksumPart's
} PAR2File;

gboolean    par2_get_md5_chunks(const char *par2file, guint64 *block_size, GList **files);
gboolean    par2_test_file(const char *directory, PAR2File *par2file, guint64 blocksize, int *num_blocks_found, int *num_blocks_missing);

#endif /* _PAR2CHECK_H_ */
