/*
    Copyright (C) 2005-2007  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _NNTPCONNECTION_H_
#define _NNTPCONNECTION_H_

#include "configuration.h"
#include "nntpgrab_plugin_base.h"
#include "collections.h"

typedef struct NNTPConnection NNTPConnection;

#define NNTPCONNECTION_TYPE_OBJECT       (nntpconnection_get_type ())
#define NNTPCONNECTION(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), NNTPCONNECTION_TYPE_OBJECT, NNTPConnection))
#define NNTPCONNECTION_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), NNTPCONNECTION_TYPE_OBJECT, NNTPConnectionClass))
#define IS_NNTPCONNECTION(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), NNTPCONNECTION_TYPE_OBJECT))
#define IS_NNTPCONNECTION_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), NNTPCONNECTION_TYPE_OBJECT))
#define NNTPCONNECTION_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), NNTPCONNECTION_TYPE_OBJECT, NNTPConnectionClass))

gboolean         nntpconnection_initialize(char **errmsg);
NNTPConnection  *nntpconnection_new(Configuration *config, ConfigServer server);
void             nntpconnection_destroy(NNTPConnection *obj);

NNTPGrabErrCode  nntpconnection_connect(NNTPConnection *obj);
void             nntpconnection_disconnect(NNTPConnection *obj);
gboolean         nntpconnection_get_is_connected(NNTPConnection *obj);
NNTPGrabErrCode  nntpconnection_get_part(NNTPConnection *obj, const char *collection_name, const char *subject, const NNTPPart *part, const char *filename);
gboolean         nntpconnection_group(NNTPConnection *obj, int conn_id, const char *newsgroup);
gboolean         nntpconnection_xover(NNTPConnection *obj, gboolean full_update);
int              nntpconnection_get_conn_id(NNTPConnection *obj);

#endif /* _NNTPCONNECTION_H_ */
