/*
    Copyright (C) 2005-2007  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _PLUGIN_NNTP_H_
#define _PLUGIN_NNTP_H_

typedef struct _plugin_nntp_exported_funcs {
    int              (*get_version) (void);

    gboolean         (*get_is_connected) (int conn_id);

    NNTPGrabErrCode  (*connect) (const char *hostname, int port, const char *username, const char *password, gboolean use_ssl, char **errmsg, int *conn_id, gpointer data);
    void             (*disconnect) (int conn_id, gpointer data);

    NNTPGrabErrCode  (*get_article_by_message_id) (int conn_id, const char *message_id, const char **headers, const char *filename, gpointer cb_data);
    NNTPGrabErrCode  (*group) (int conn_id, const char *newsgroup, int *num_articles, int *start_article, int *end_article, gpointer data);
    NNTPGrabErrCode  (*xover) (int conn_id, int start_range, int end_range, gpointer data);
} PluginNNTPExportedFuncs;

typedef gboolean (*plugin_nntp_init_func) (PluginNNTPImportedFuncs funcs);

#endif /* _PLUGIN_NNTP_H_ */
